﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Trees
{
    public class TreeNode
    {
        private int value;
        private List<TreeNode> children;

        public List<TreeNode> Children { get => children; set => children = value; }
        public int Value { get => value; set => this.value = value; }

        public TreeNode(int Value) 
        { 
            children = new List<TreeNode>();
            this.value = Value;
        }
        public void AddChild(int Value) 
        { 
            children.Add(new TreeNode(Value));
        }
        public void RemoveChild(int Value)
        {
            for (int i = 0; i < children.Count; i++) 
            {
                TreeNode child = children[i];
                if (child.Value == Value)
                {
                    children.RemoveAt(i);
                    return;
                }
                child.RemoveChild(Value);
            }
        }
        public TreeNode? GetNodeRef(int Value) 
        {
            TreeNode? output;
            if (this.Value == Value)
            {
                return this;
            }

            foreach (TreeNode child in children)
            {
                output = child.GetNodeRef(Value);
                if (output is not null) 
                {
                    return output;
                }
            }
            return null;
        }
    }
}
